using System;
using System.Collections;
using UnityEngine;

public class Guard : MotionNote
{
    enum Hand { Both, Left, Right }
    Hand hand;

<<<<<<< HEAD
    MotionState prepare, done;

    private static Sprite image;
=======
    private static Sprite imageB = LoadNewSprite("");
    private static Sprite imageL = LoadNewSprite("");
    private static Sprite imageR = LoadNewSprite("");

>>>>>>> 264d73d3155335b370d118cddd1ace963868a28c
    public override Sprite Image
    {
        get
        {
            switch (hand)
            {
                default:
                case Hand.Both:
                    return imageB;
                case Hand.Left:
                    return imageL;
                case Hand.Right:
                    return imageR;
            }
        }
    }

    private bool isChecked = false;
    public override bool IsChecked
    {
        get
        {
            return isChecked;
        }
    }

<<<<<<< HEAD
    public Guard(string key, float timing) : this(timing)
=======
    public Guard(string key, float timing) : this(key, timing, 0f)
    {
    }

    public Guard(string key, float timing, float end = 0f) : this(timing, end)
>>>>>>> 264d73d3155335b370d118cddd1ace963868a28c
    {
        switch (key)
        {
            case "BG":
                hand = Hand.Both;
                image = LoadNewSprite("BG");
                prepare = MotionState.GUARD_BASE_LEFT | MotionState.GUARD_BASE_RIGHT
                | MotionState.HAND_MOVE_DOWN_LEFT | MotionState.HAND_MOVE_DOWN_RIGHT;
                done =  MotionState.GUARD_BASE_LEFT | MotionState.GUARD_BASE_RIGHT
                | MotionState.HAND_MOVE_UP_LEFT | MotionState.HAND_MOVE_UP_RIGHT;
                break;
            case "LG":
                hand = Hand.Left;
                image = LoadNewSprite("LG");
                prepare = MotionState.GUARD_BASE_LEFT
                | MotionState.HAND_MOVE_DOWN_LEFT;
                done =  MotionState.GUARD_BASE_LEFT
                | MotionState.HAND_MOVE_UP_LEFT;
                break;
            case "RG":
                hand = Hand.Right;
                image = LoadNewSprite("RG");
                prepare = MotionState.GUARD_BASE_RIGHT
                | MotionState.HAND_MOVE_DOWN_RIGHT;
                done = MotionState.GUARD_BASE_RIGHT
                | MotionState.HAND_MOVE_UP_RIGHT;
                break;
        }
    }
    public Guard(float timing) : base(timing)
    {
    }

<<<<<<< HEAD
     public override void Checkpoint()
=======
    public override IEnumerator Checkpoint(MotionNote obj)
>>>>>>> 264d73d3155335b370d118cddd1ace963868a28c
    {
        IsChecked = (InputManager.Instance.CurrentMotionState
            & prepare) != 0;
    }

    public override bool FinalJudgeAction()
    {
<<<<<<< HEAD
        return (InputManager.Instance.CurrentMotionState
            & done) != 0;
=======
        return false;
>>>>>>> 264d73d3155335b370d118cddd1ace963868a28c
    }
}
